#include "kabine.pov"
#include "kabine4.pov"
#include "T_bodenbelag.pov"
#include "maschinen_zentrale.pov"

#declare Eps=1E-3;

#local kabinen_deck =
    union {
	object {
	    kabine1
	    translate <0, 0, 0>
	}
	object {
	    kabine1
	    scale <-1, 1, +1>
	    translate <0, 0, 0>
	}

	object {
	    kabine1
	    translate <0, 0, 0>
	    rotate <0, 90, 0>
	}
	object {
	    kabine1
	    scale <-1, 1, +1>
	    translate <0, 0, 0>
	    rotate <0, 90, 0>
	}

	#ifndef (SCHNITT_1)
	object {
	    kabine1
	    translate <0, 0, 0>
	    rotate <0, 180, 0>
	}
	#end
	object {
	    kabine1
	    scale <-1, 1, +1>
	    translate <0, 0, 0>
	    rotate <0, 180, 0>
	}

	object {
	    kabine1
	    translate <0, 0, 0>
	    rotate <0, 270, 0>
	}
	#ifndef (SCHNITT_1)
	object {
	    kabine1
	    scale <-1, 1, +1>
	    translate <0, 0, 0>
	    rotate <0, 270, 0>
	}
	#end

	#local A0 = 0;
	#while (A0 < 360) 
	    #local I1 = 0;
	    #while (I1 < 4) 
		#local A = A0 + (-1.5 + I1) * Kw;
		#local ss = 1;
		#ifdef (SCHNITT_1)
		    #local pp = vrotate(<0, 0, 1>, <0, A, 0>);
		    #if (pp.x < 0 & pp.z < 0) 
			#local ss = 0;
		    #end
		#end
		#if (ss) 
		    object {
			kabine4
			rotate <0, A, 0>
		    }
		#end
		#local I1 = I1 + 1;
	    #end
	    #local A0 = A0 + 90;
	#end

	difference {
	    intersection {
		cone {
		    <0, 0, 0> 46.6
		    <0, -0.1, 0> 46.7
		    texture { T_bodenbelag }
		}
		torus {
		    (15+6)/2, (15-6)/2
		}
	    }
	    box {
		<-5.9, -0.1-Eps, -1>
		<-10, 0+Eps, +1>
		texture { T_bodenbelag }
	    }
	    box {
		<-5.9, -0.1-Eps, -1>
		<-10, 0+Eps, +1>
		texture { T_bodenbelag }
		rotate <0, 90, 0>
	    }
	    box {
		<-5.9, -0.1-Eps, -1>
		<-10, 0+Eps, +1>
		texture { T_bodenbelag }
		rotate <0, 180, 0>
	    }
	    box {
		<-5.9, -0.1-Eps, -1>
		<-10, 0+Eps, +1>
		texture { T_bodenbelag }
		rotate <0, 270, 0>
	    }
	    #ifdef (SCHNITT_1)
	    intersection {
		torus {
		    23, 23
		}
		plane { 
		    <0, 0, -1> 0
		    rotate <0, 45, 0>
		}
		plane { 
		    <0, 0, +1> 0
		    rotate <0, -45, 0>
		}
		rotate <0, 135, 0>
		translate <0, 10.0, 0>
	    }
	    #end
	}
    }

#declare deck_11 = 
    union {

	// Deck
	difference {
	    cone {
		<0,  0.2, 0> 15
		<0, -0.2, 0> 15
		texture { T_arkonstahl }
	    }
	}

	// Zentrale
	object {
	    maschinen_zentrale
	    translate <0, 0.2, 0>
	}
	


	// Kabinen


	object {
	    kabinen_deck
	    translate <0, 14.8-5*2.84, 0>
	}

	// Stiegenhaeuser
	#local J = 0;
	#while (J < 360)
	    union {
		#local I= 0;
		#while (I < 16)
		    box {
			<-10+(I+1)*0.2, 14.8-4*2.84 - I*0.2025,        0>
			<-10+I*0.2,     14.8-4*2.84 - I*0.2025 - 0.1, +1>
			texture { T_bodenbelag }
		    }
		    #local I = I + 1;
		#end

		#local I= 0;
		#while (I < 2)
		    box {
			<-10+(I+1)*0.4, 14.8-5*2.84 - I*0.200,        0>
			<-10+I*0.4,     14.8-5*2.84 - I*0.200 - 0.1, -1>
			texture { pigment { rgb <1, 1, 0> } }
		    }
		    #local I = I + 1;
		#end

		rotate <0, J, 0>
	    }

	    #local J = J + 90;
	#end

    }



