#include "colors.inc"
#include "shapes.inc"
#include "textures.inc"
#include "metals.inc"
#include "stones.inc"
#include "landestuetze.pov"

#declare SCHNITT_1 = 1;	// Quadrant -/*/-
#declare XZ_GRID   = 0;

global_settings {
        assumed_gamma 1.0
        ambient_light rgb<0.5, 0.5, 0.5>
}
background { color rgb<0.2, 0.4, 0.8>  }
light_source {
    <-200, 200, -200>
    color White
}

#local CP = <-90, 60, -90>;
light_source {
    CP
    color White*0.5
}
camera {
	orthographic
        location CP
        look_at <-0, 30, -0>
	angle 20
}

#include "huelle.pov"
#include "deck_05.pov"
#include "deck_06.pov"

union {
    object {
	deck_05
    }
    object {
	deck_06
    }
	#local i = 0;
	#while (i < 12) 
	    object { 
		landestuetze 
		rotate <0, i * 30, 0>
	    }
	    #local i = i + 1;
	#end
    #if (XZ_GRID)
	#local xx = -40;
	#while (xx <= 40) 

	    cylinder {
		<xx, 0, -100>, 
		<xx, 0, +100>, 
		0.1 + 0.1 * (mod(xx, 10) = 0)
		pigment { color <1, 0, 0> }
	    }
	    #local xx = xx + 1;
	#end
	#local zz = -40;
	#while (zz <= 40) 

	    cylinder {
		<-100, 0, zz>, 
		<+100, 0, zz>, 
		0.1 + 0.1 * (mod(zz, 10) = 0)
		pigment { color <0, 0, 1> }
	    }
	    #local zz = zz + 1;
	#end
    #end
    translate <0, 55, 0>
}


cylinder {
    <0, 0, 0>,
    <0, -1, 0>, 1000
    pigment {
	radial
	color_map{
	    [0.1 rgb 0.1 ]
	    [0.1 White]
	}
	frequency 16
    }
}




