#include "glass.inc"
#include "colors.inc"
#include "shapes.inc"
#include "textures.inc"
#include "metals.inc"
#include "stones.inc"

#declare SCHNITT_1 = 1;	// Quadrant -/*/-

global_settings {
        assumed_gamma 1.0
        ambient_light rgb<0.5, 0.5, 0.5>
}
background { color rgb<0.2, 0.4, 0.8>  }
light_source {
    <-200, 200, -200>
    color White
}

#local CP = <22, -44, -100>;
light_source {
    CP
    color White*0.5
}
camera {
	// orthographic
        location CP
        look_at <22, -44.0, 0>
	angle 40
}

#include "huelle.pov"
#include "landestuetze.pov"

union {
    object {
	landestuetze
    }
}


cylinder {
    <0, 0, 0>,
    <0, -1, 0>, 1000
    pigment {
	radial
	color_map{
	    [0.1 rgb 0.1 ]
	    [0.1 White]
	}
	frequency 16
    }
    translate <0, -55, 0>
}

difference {
    cylinder {
	<0, 0, -1>
	<0, 0, +1>, 50
    }
    cylinder {
	<0, 0, -1.5>
	<0, 0, +1.5>, 48
    }
    object {
	landestuetze_neg
    }

    texture { T_Ruby_Glass }
    interior { I_Glass }
}

/*
cone {
    <0, 0, 0>, 0
    <1000, 0, 0>, 10
    pigment { color <1, 0, 0> }
}

cone {
    <0, 0, 0>, 0
    <0, 1000, 0>, 10
    pigment { color <0, 1, 0> }
}

cone {
    <0, 0, 0>, 0
    <0, 0, 1000>, 10
    pigment { color <0, 0, 1> }
}
*/
